﻿using System;
using System.Collections;
using System.Collections.Generic;

public class NaturalNumber : IEnumerable<int>
{
    public IEnumerator<int> GetEnumerator()
    {
        return new NaturalNumberEnumerator();
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
        return new NaturalNumberEnumerator();
    }

    public class NaturalNumberEnumerator : IEnumerator<int>
    {
        int _current;

        public int Current
        {
            get { return _current; }
        }

        object IEnumerator.Current
        {
            get { return _current; }
        }

        public void Dispose()
        {
        }

        public bool MoveNext()
        {
            _current ++;

            return true;
        }

        public void Reset()
        {
            _current = 0;
        }
    }
}

class YieldNaturalNumber
{
    public static IEnumerable<int> Next(int max)
    {
        int _start = 0;

        while (true)
        {
            _start++;
            if (max < _start)
            {
                yield break;
            }

            yield return _start;
        }
    }
}

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            //NaturalNumber number = new NaturalNumber();
            //foreach (int n in number)
            //{
            //    Console.WriteLine(n);
            //}

            foreach (int n in YieldNaturalNumber.Next(10))
            {
                Console.WriteLine(n);
            }
        }
    }
}
